<?php

include '../Include/xplanetbg.inc.php';

$hintergrundbild = "xplanet xpb xp". $xplanet_bg . " b" . $xplanet_bg . ".123"; /* Ist eigentlich kein Bild mehr, sondern eine "class" */
$description = "„Für alles was Sie kaufen, zahlen Sie 30% drauf. Täglich fließen so in Deutschland 980 Mio. Euro Zinsen von Arm zu Reich.“ Hier wird diese Aussage der „Initiative Natürliche Wirtschafts-Ordnung“ verständlich illustriert.";
$keywords=", Schulden, Finanzkrise, Wirtschaftskrise, Umverteilung";
$titel = "Die Umverteilung durch Zinsen grafisch veranschaulicht";
$root = "../";

$css = "
 img.wborder {border-width:1px;border-color:white;border-style:solid;margin:0.5em; }
 blockquote {font-style:italic;margin-bottom:0.6em;}
 img.rechtsBild, img.linksBild {border-color:white;}

 table { width:90%;max-width:45rem; }
 th.g  { min-width: 12rem; }

 table th { text-align:center; }
 table td, th.g, input { text-align:right; }
 input { border:0px;margin:0px;padding:1px; }

 tr.anteil { font-size:80%; }

 td.ergebnis, td.nergebnis, td.pergebnis { width:3em; }
 td.ergebnis { color:black;}
 td.nergebnis { color:red;}
 td.pergebnis { color:green;}
 ";

if (!function_exists('svg_embed')){
  include $root . 'Include/svg_embed.inc';
}

/* Name der tatsächlichen Inhaltsdatei: */
$filename = __FILE__;

$ietext = 'Ihr Browser ist zu alt! Mit <a href="http://de.wikipedia.org/wiki/Internet_Explorer_9" title="Internet-Explorer-Artikel in Wikipedia">Version 9</a> (Anfang 2011?) kann auch der <i>Internet Explorer</i> endlich, was andere Browser wie Firefox, Opera oder Safari schon seit Jahren können: <a href="http://de.wikipedia.org/wiki/Scalable_Vector_Graphics" title="SVG erklärt">SVG</a> darstellen.';

function number_formatd($n, $decimals = 1){
    return number_format($n, $decimals, ',', '.');
}

function d_to_e($n){
    $clean = str_replace(array('.',','), array('','.'), $n);
    if (!is_numeric($clean)){
        throw new Exception("<b>Fehler:</b> ungültige Eingabe (" . htmlspecialchars($n) . ").");
    }
    return $clean;
}

if ($_POST['anwenden']) {
    $zinsanteil_ber = isset($_POST['zinsanteil_ber']);
    $zeige_summen = isset($_POST['zeige_summen']);
    try {
        $zinssatz_n = d_to_e($_POST['zinssatz_n']) / 100;
        $zinssatz_r = d_to_e($_POST['zinssatz_r']) / 100;
        $zinsanteil = d_to_e($_POST['zinsanteil']) / 100;
        $haushalte_pro_gruppe = d_to_e($_POST['haushalte_pro_gruppe']);
        reset($_POST);

        $v[1] = d_to_e(current($_POST));
        for ($i = 2; $i <= 10; $i++)
            $v[$i] = d_to_e(next($_POST));
        for ($i = 1; $i <= 10; $i++)  
            $ea[$i] = d_to_e(next($_POST));
        for ($i = 1; $i <= 10; $i++)  
            $s[$i] = d_to_e(next($_POST));
    } catch (Exception $exception) {
        $text = $exception->getMessage();
    }
} else if (!isset($_GET['preset'])) {
    /* Vermögen: */
    $v = array(1 => 0, 0, 0, 3, 12, 60, 126, 234, 597, 1965);
    /* Einkommen: */
    /*  $e = array(1 => 12, 19, 24, 28, 32, 38, 43, 49, 59, 101); */
    /* Einkomen aus Arbeit: */
    $ea = array(1 => 12, 19, 24, 27.9, 31.5, 35.7, 38.2, 41.1, 36.3, 10.6);
    /* Ersparnisse: */
    $s = array(1 => 0, 0, 0.3, 1.1, 2.2, 3.6, 4.7, 5.5, 9.7, 16.8);
    /* Zinssätze "normal" und "reich" */
    $zinssatz_n = 0.038;
    $zinssatz_r = 0.046;
    $zinsanteil = 0.348;
    $haushalte_pro_gruppe = 3.8;
    $zeige_summen = FALSE;
    $zinsanteil_ber = FALSE;
} else if ($_GET['preset'] == 'equal') {
    /* Vermögen: */
    $v = array(1 => 299.7, 299.7, 299.7, 299.7, 299.7, 299.7, 299.7, 299.7, 299.7, 299.7);
    /* Einkomen aus Arbeit: */
    $ea = array(1 => 12, 19, 24, 27.9, 31.5, 35.7, 38.2, 41.1, 36.3, 10.6);
    /* Ersparnisse: */
    $s = array(1 => 0, 0, 0.3, 1.1, 2.2, 3.6, 4.7, 5.5, 9.7, 16.8);
    /* Zinssätze "normal" und "reich" */
    $zinssatz_n = 0.038;
    $zinssatz_r = 0.038;
    $zinsanteil = 0.348;
    $haushalte_pro_gruppe = 3.8;
    $zeige_summen = FALSE;
    $zinsanteil_ber = FALSE;
} else if ($_GET['preset'] == 'zero') {
    /* Vermögen: */
    $v = array(1 => 0, 0, 0, 3, 12, 60, 126, 234, 597, 1965);
    /* Einkomen aus Arbeit: */
    $ea = array(1 => 12, 19, 24, 27.9, 31.5, 35.7, 38.2, 41.1, 36.3, 10.6);
    /* Ersparnisse: */
    $s = array(1 => 0, 0, 0.3, 1.1, 2.2, 3.6, 4.7, 5.5, 9.7, 16.8);
    /* Zinssätze "normal" und "reich" */
    $zinssatz_n = 0;
    $zinssatz_r = 0;
    $zinsanteil = 0;
    $haushalte_pro_gruppe = 3.8;
    $zeige_summen = FALSE;
    $zinsanteil_ber = FALSE;
} else if ($_GET['preset'] == 'half') {
    /* Vermögen: */
    $v = array(1 => 0, 0, 0, 1.5, 6, 30, 63, 117, 298.5, 982.5);
    /* Einkomen aus Arbeit: */
    $ea = array(1 => 12, 19, 24, 27.9, 31.5, 35.7, 38.2, 41.1, 36.3, 10.6);
    /* Ersparnisse: */
    $s = array(1 => 0, 0, 0.3, 1.1, 2.2, 3.6, 4.7, 5.5, 9.7, 16.8);
    /* Zinssätze "normal" und "reich" */
    $zinssatz_n = 0.038;
    $zinssatz_r = 0.038;
    $zinsanteil = 0.348;
    $haushalte_pro_gruppe = 3.8;
    $zeige_summen = FALSE;
    $zinsanteil_ber = TRUE;
}	  
           
/* Zinsanteile an Haushaltseinkommen und -ausgaben werden berechnet: */
for ($i = 1; $i <= 10; $i++){
  $ez[$i] = ($i < 10 ? $v[$i] * $zinssatz_n : $v[$i] * $zinssatz_r); /* Zinseinkommen */
  $e[$i] = $ea[$i] + $ez[$i];
  if ( $s[$i] > $e[$i] ) /* Es ist nicht möglich, mehr zu sparen, als man einnimmt */
    $s[$i] = $e[$i];
  $a[$i] = $e[$i] - $s[$i];
}

if ($zinsanteil_ber) {
  $alle_ausgaben = 0;
  $alle_zinsen = 0;
  for ($i = 1; $i <= 10; $i++){
    $alle_zinsen += $ez[$i];
    $alle_ausgaben += $a[$i];
  }
  $zinsanteil = $alle_zinsen / $alle_ausgaben;
}

for ($i = 1; $i <= 10; $i++)
  $az[$i] = $a[$i] * $zinsanteil; /* Zinslasten */

/* Die Summen für die Gruppen werden nur berechnet, wenn sie gezeigt werden sollen */
if ($zeige_summen){
  $v_gruppensumme = '<tr style="font-style:italic;">
<td class="xpw">in Mrd € je Gruppe</td>';
  $e_gruppensumme = $v_gruppensumme;
  $s_gruppensumme = $v_gruppensumme;
  $a_gruppensumme = $v_gruppensumme;
  $z_gruppensumme = $v_gruppensumme;
  for ($j = 1; $j <= 10; $j++){
      $v_gruppensumme = $v_gruppensumme . '<td>' . number_formatd($v[$j] * $haushalte_pro_gruppe) . '</td>';
      $e_gruppensumme = $e_gruppensumme . '<td>' . number_formatd($e[$j] * $haushalte_pro_gruppe) . '</td>';
      $s_gruppensumme = $s_gruppensumme . '<td>' . number_formatd($s[$j] * $haushalte_pro_gruppe) . '</td>';
      $a_gruppensumme = $a_gruppensumme . '<td>' . number_formatd($a[$j] * $haushalte_pro_gruppe) . '</td>';
    $saldo = ($ez[$j] - $az[$j]) * $haushalte_pro_gruppe;
    $z_gruppensumme = $z_gruppensumme . '<td class="' . ($saldo >= 0? 'p' : 'n') . 'ergebnis">' . number_formatd($saldo) . '</td>';   
  }
  $v_gruppensumme = $v_gruppensumme . '</tr>';
  $z_gruppensumme = $z_gruppensumme . '</tr>';
  $e_gruppensumme = $e_gruppensumme . '</tr>';
  $s_gruppensumme = $s_gruppensumme . '</tr>';
}

for ($i = 1; $i <= 10; $i++){
  $v_summe += $v[$i]; /* nicht die Summe aller Vermögen, sondern nur die je eines Haushalts pro Gruppe */
  $e_summe += $e[$i]; /* nicht die Summe aller Einkommen... */
  $s_summe += $s[$i]; /* nicht die Summe aller Ersparnisse... */
  $a_summe += $a[$i]; /* nicht die Summe aller Ausgaben... */
}

for ($i = 1; $i <= 10; $i++){
  $v_gruppenprozent = $v_gruppenprozent . '<td>' . number_formatd(($v[$i] / $v_summe * 100)) . '% </td>';
  $v_gruppeneink =  $v_gruppeneink . '<td><input name="v' . $i . '" type="text" size="4" maxlength="7" value="' . number_format($v[$i], 1, ",", ".") . '"></td>';
  $e_gruppenprozent = $e_gruppenprozent . '<td>' . number_formatd(($e[$i] / $e_summe * 100)) . '% </td>'; 
  $e_zinsen = $e_zinsen . '<td>' . number_formatd($ez[$i]) . '</td>';   
  $e_arbeit = $e_arbeit . '<td><input name="ea' . $i . '" type="text" size="4" maxlength="7" value="' . number_formatd($ea[$i]) . '"></td>';
  $e_gruppeneink = $e_gruppeneink . '<td>' . number_formatd($e[$i]) . '</td>';   
  $s_gruppenprozent = $s_gruppenprozent . '<td>' . number_formatd(($s[$i] / $s_summe * 100)) . '% </td>'; 
  $s_gruppeneink = $s_gruppeneink .  '<td><input name="s' . $i . '" type="text" size="4" maxlength="7" value="' . number_formatd($s[$i]) . '"></td>';
  $a_gruppenprozent = $a_gruppenprozent . '<td>' . number_formatd(($a[$i] / $a_summe * 100)) . '% </td>'; 
  $a_zinsen = $a_zinsen . '<td>' . number_formatd($az[$i]) . '</td>';   
  $a_gruppenausg = $a_gruppenausg .  '<td class="ergebnis">' . number_formatd($a[$i]) . '</td>';
}

/* Zinssaldenberechnung */
for ($k = 1; $k <= 10; $k++){
  $saldo = $ez[$k] - $az[$k];
  $saldosumme += $saldo;
  $zinssaldo = $zinssaldo . '<td class="' . ($saldo >= 0? 'p' : 'n') . 'ergebnis">' . number_formatd($saldo) . '</td>';
}

/* Parameter für Visualisierung */
for ($k = 1; $k <= 10; $k++){
  $parameter = $parameter . "&amp;e$k=" . $e[$k] . "&amp;a$k=" . $a[$k] . "&amp;z$k=" . $ez[$k] . "&amp;l$k=" . $az[$k];
}

$theader = '<table>
<tr>
  <th class="g">Gruppe</th>
  <th>1</th><th>2</th><th>3</th><th>4</th><th>5</th><th>6</th><th>7</th><th>8</th><th>9</th><th>10</th>
</tr>
';

$text = $text . '

<h2>Verteilung der <a href="#verteilung" title="Mehr zur Vermögensverteilung">Vermögen</a>:</h2>

<form method="post" action="." accept-charset="utf-8">

' . $theader . '
<tr>
  <td title="in Tausend € je Haushalt">in Tsd. € je Hh.</td>' .
  $v_gruppeneink . '
</tr>'
.  $v_gruppensumme . '
<tr class="anteil">
  <td>Anteile</td>' .
  $v_gruppenprozent . '
</tr>
</table>

<h2 title="Zinsen aus Vermögen + sonstige Einkommen">Verteilung der Haushalts-Einkommen:</h2>

' . $theader . '
<tr>
  <td title="Zinseinnahmen in Tauſend € je Haushalt">aus Zinſen*</td>' .
  $e_zinsen . '  
</tr>
<tr>
  <td title="Einkommen z.B. aus Arbeit / in Tausend € je Haushalt">ſonſtiges Eink.</td>' .
  $e_arbeit . '
</tr>
<tr>
  <td title="in Tauſend € je Haushalt">in Tsd. € je Hh.</td>' .
  $e_gruppeneink . '
</tr>' .
  $e_gruppensumme . '
<tr class="anteil">
  <td>Anteile</td>' .
  $e_gruppenprozent . '
</tr>
</table>

<h2 title="Wer spart wieviel?">Verteilung der jährlichen Ersparniſſe:</h2>

' . $theader . '
<tr>
  <td title="in Tauſend € je Haushalt">in Tſd. € je Hh.</td>' .
  $s_gruppeneink . '
</tr>' .
  $s_gruppensumme . '
<tr class="anteil">
  <td>Anteile</td>' .
  $s_gruppenprozent . '
</tr>
</table>

<h2 title="Einkommen minus Ersparnisse">Verteilung der Haushalts-Ausgaben:</h2>

' . $theader . '
<tr class="xpw">
  <td title="in Tausend € je Haushalt">in Tsd. € je Hh.</td>' .
  $a_gruppenausg . '
</tr>
<tr>
  <td title="Zinslasten in Tausend € je Haushalt">davon Zinslasten*</td>' .
  $a_zinsen . '  
</tr>' .
  $a_gruppensumme . '
<tr class="anteil">
  <td>Anteile</td>' .
  $a_gruppenprozent . '
</tr>
</table>


<h2>Zinsumverteilung:</h2>

' . $theader . '
<tr>
  <td title="jährliche Zinslasten in Tausend € je Haushalt">Zinslasten<small> (in Tsd. € / Hh.)</small></td>' .
  $a_zinsen . '
</tr>
<tr>
  <td title="jährliche Zinseinnahmen in Tausend € je Haushalt">Zinſen<small> (in Tsd. € / Hh.)</small></td>' .
  $e_zinsen . '
</tr>
<tr class="xpw">
  <td title="jährlicher Zins-Saldo in Tausend € je Haushalt">Zinsſaldo<small> (in Tsd. € / Hh.)</small></td>' .
  $zinssaldo . '  
</tr>'
. $z_gruppensumme . '
</table>

<h3>Einſtellungen:</h3>

<div style="float:left;"><input type="submit" value="Anwenden" name="anwenden" title="Berechnet die Umverteilung nach den Nutzereingaben"></div>

<div style="margin-left:6em;margin-top:0em;">
Zinssatz „normal“: <input name="zinssatz_n" type="text" size="3" maxlength="4" title="Zinssatz für die unteren neun Zehntel" value="' . number_formatd($zinssatz_n * 100) . '">% 
&nbsp; Zinssatz „reich“: <input name="zinssatz_r" type="text" size="3" maxlength="4" title="Zinssatz für das reichste Zehntel" value="' . number_formatd($zinssatz_r * 100) . '">% 
<br>
<a href="http://www.humane-wirtschaft.de/pdf_z/creutz_zinsanteil-in-preisen.pdf" title="Diskussion zum Zinsanteil in den Preisen (PDF)">Zinsanteil</a>: <input name="zinsanteil" type="text" size="3" maxlength="4" value="' . number_formatd($zinsanteil * 100) . '" title="durchschnittlicher Zinsanteil in den Ausgaben">%
<input name="zinsanteil_ber" type="checkbox" ' . ( $zinsanteil_ber ? 'checked ' : '') . 'title="Berechnet Zinsanteil an Ausgaben passend zu Zinseinkommen aus Vermögen"> automatisch neu berechnen
<br><i>Gruppensummen</i> anzeigen: <input name="zeige_summen" type="checkbox" '. ($zeige_summen ? 'checked ' : '') . 'title="Wenig zusätzliche Information">
&nbsp; Haushalte pro Gruppe (in Mill.): <input name="haushalte_pro_gruppe" type="text" size="4" maxlength="5" title="Nur relevant, wenn Gruppensummen angezeigt werden" value="' . number_formatd($haushalte_pro_gruppe) . '">
</div>
</form>

<div style="width:90%;margin:auto;margin-top:1em;margin-bottom:1em;color:black;" class="daten xpw">'
 . svg_embed("umverteilung.php?titel=Umverteilung_durch_Zins" . $parameter, "umverteilung.png", "100%", "", "475", "305", "Visualisierung", $ietext, '', "", "") . '</div>

<p>Die zehn Haus­halts­grup­pen beſte­hen je­weils aus ' . number_formatd($haushalte_pro_gruppe) . ' Mil­lio­nen Haus­hal­ten und ſind nach ih­rem Ver­mö­gen geſtaf­felt. Als Geſamt­ver­mö­gen er­ge­ben sich ' . number_formatd($v_summe * $haushalte_pro_gruppe) . ' Mrd €.</p>

<p>Sum­me über die Sal­do-Zei­le (soll­te na­he 0 sein): ' . number_formatd($saldosumme) . ' Tsd. € <small> - So viel Ge­winn (falls po­si­tiv) ha­ben 10 Durchſchnitts­haus­hal­te, je ei­ner pro Grup­pe, zu­sam­men aus dem Zinsſyſtem (ver­mut­lich zu Laſten der Un­ter­neh­men, des Staa­tes oder des Aus­lands) - insgesamt ' . number_formatd($saldosumme * $haushalte_pro_gruppe, 2) . ' Milliarden €.</small></p>

' .

svg_embed("vermoegensverteilung_bpb_web.svg", "vermoegensverteilung_bpb_web.png", "32em", "", "450", "365", "Vermögensverteilung", $ietext, '', "margin:1em;float:right;clear:both;", " class='xpw' id='verteilung'")

.

'
<p>Al­le Zah­len, mit de­nen die Be­rech­nun­gen durch­ge­führt wer­den, ſind durch die Ein­ga­be­fel­der ver­än­der­bar! Die vor­ein­ge­ſtell­ten Zah­len ſtam­men aus dem Ar­ti­kel <i>Wie groß iſt die Um­ver­tei­lung durch den Zins?</i> von <a href="http://helmut-creutz.de/" title="Netzpräsenz des Aktivisten">Hel­mut Creutz</a> in <a href="http://inwo.de/index.php?id=139" title="Infoseite zur Zeitschrift">Fair­co­no­my</a> <a href="http://inwo.de/uploads/media/ausgabe-2010-3_01.pdf" title="PDF-Version der Ausgabe herunterladen">Nr. 3/ 2010</a> (S. 4 - 9). Auch der Auf­bau mei­ner Ta­bel­len iſt aus ſei­nen Ta­bel­len ab­ge­lei­tet. Die er­zeug­te Gra­fik lehnt ſich al­ler­dings we­ni­ger an die Dar­ſtel­lun­gen von Hel­mut Creutz an, als an die Dar­ſtel­lung der <a href="http://www.rheinahrcampus.de/fileadmin/prof_seiten/kremer/applets/DynamicAnalysis/AppletDynamicAnalysis.html" title="...zeigt sich, dass die untersuchten Ökonomien mit realistischen Anfangsdaten und unter Standardannahmen langfristig instabil werden...">Si­mu­la­tion</a> des Wirt­ſchafts­ma­the­ma­ti­kers <a href="http://kremer.rheinahrcampus.de/" title="Seite des Wissenschaftlers">Prof. Dr. Jür­gen Kre­mer</a>.</p>

<p>Den vor­ein­ge­ſtell­ten Wer­ten ent­ſpre­chen­de Vi­ſua­li­ſie­run­gen der an­zu­neh­men­den <b>Ver­mö­gens­ver­tei­lung</b> in Deutſch­land ſind bei der <a href="http://www.bpb.de/wissen/U4CJQA,0,Verm%F6gensverteilung.html" title="Hier wird von 8 statt von etwa 10 Billionen € Vermögen ausgegangen, aber der Unterschied ist für das Prinzip irrelevant">Bun­des­zen­tra­le für Po­li­ti­ſche Bil­dung</a> zu fin­den.
</p>

<p>Ver­läſſ­li­che Zah­len über die Ver­mö­gens­ver­tei­lung zu be­kom­men iſt gar nicht ſo leicht. Das Syſ­tem funk­tio­niert aber in der oben dar­ge­ſtell­ten Wei­ſe - un­ab­hän­gig da­von, wie hoch die Wer­te im ein­zel­nen genau ſind. Hier ein paar in­ter­eſſan­te Vor­ein­ſtel­lun­gen:</p>

<ul>
<li>Das Ge­ſamt­ver­mö­gen iſt <a href="?preset=equal" title="Eine solche Situation wird und braucht es nie geben">gleich­mä­ßig auf die 10 Grup­pen ver­teilt</a>.</li>
<li><a href="?preset=zero" title="Das ist das Ziel mit Freigeld - eine weniger auseinanderdriftende Vermögensverteilung wäre die Folge">Zin­ſen und Zinſan­teil ſind 0</a> (wo­mit die Rei­chen nicht mehr ſo viel ſpa­ren und nichts mehr aus­ge­ben kön­nen).</li>
<li><a href="?preset=half" title="Wieviel besser wäre das für die meisten Menschen?">Al­le Ver­mö­gen ſind nur halb ſo hoch</a> (der Zinſan­teil ent­ſpre­chend ge­rin­ger), die Ein­kom­men gleich.</li>
</ul>

<p>Be­ſon­ders in­ter­eſſant iſt die Ge­gen­über­ſtel­lung die­ſer Zin­ſum­ver­tei­lung mit der <b><a href="../freimarkt/" title="Negativ-Zinsen auf Bargeld, Vermögen werden irrelevant">Frei­geld-Um­ver­tei­lung</a></b>!</li>

<p><small>Es iſt mög­lich, daſs die Ver­mö­gen noch nicht ſo weit auſ­ein­an­der­drif­ten, wie in der er­ſten Ta­bel­le vor­ein­ge­ſtellt. Laut <a href="http://www.destatis.de/jetspeed/portal/cms/Sites/destatis/Internet/DE/Content/Statistiken/WirtschaftsrechnungenZeitbudgets/EinkommensVerbrauchsstichproben/Aktuell.psml" title="Pressemitteilung des Statistischen Bundesamts zur Einkommens-Verbrauchs-Stichproben">EVS 2008</a> be­zieht ein deut­ſcher Haus­halt im Durch­ſchnitt (ſi­cher iſt das arith­me­ti­ſche Mit­tel ge­meint) nur 385 €/ Mo­nat aus Zin­ſen - wo­bei der Durch­ſchnitt bei der ge­ge­be­nen Ver­mö­gens­ver­tei­lung we­nig auſ­ſagt: die Hauſ­hal­te im obe­ren Ver­mö­genſ­zehn­tel be­kämen da­von ih­rem Ver­mö­genſan­teil ent­ſpre­chend mehr als 61%, al­ſo im Durch­ſchnitt mehr als 385 * 10 * 0,61 = 2349 € pro Mo­nat (28188 € / Jahr). Für die zwei­te Grup­pe er­ge­ben ſich ent­ſpre­chend 385 * 10 * 0,19 = 732 € / Mo­nat und für die üb­ri­gen acht Grup­pen im Durch­ſchnitt ma­ge­re 385 * 10 * 0,2 / 8 = 96 € / Mo­nat. Viel­leicht wer­den in der EVS Zin­ſen aber auch ein­fach wört­li­cher ge­nom­men und Mie­tein­nah­men und Ak­ti­en­ge­win­ne nicht da­zu­ge­rech­net.</small>
</p>

<p><small>*In den Ta­bel­len wer­den die Zin­ſen als <i>Ver­mö­gen mal Zinſ­ſatz</i> be­rech­net, die Zins­laſ­ten als <i>Auſ­ga­ben mal Zinſan­teil</i>.</small></p>

<p><small>Die Auſ­ga­ben ſind be­rech­net als „Ein­kom­men“ - „Er­ſpar­niſ­ſe“.</small></p>

<p><small>Die <a href="quelle.tgz">Quell­tex­te</a> <i>die­ſer Sei­te</i> und der <i>SVG-Gra­fik</i> kön­nen ein­ge­ſe­hen und wei­ter­ver­ar­bei­tet wer­den.</small></p>

';

include '../Include/layout.inc.php';

?>
